local vc = require "venuscore"
local ae = require "apolloengine"
local mathfunction = require "mathfunction"

local MeanFilter = vc.VenusBehavior:extend("MeanFilter");

function MeanFilter:Initialize(layer)

end

function MeanFilter:_OnAwake()
  if self.ReferenceTex == nil then
    self.ReferenceTex= ae.TextureEntity();
    self.ReferenceTex:PushMetadata(ae.TextureReferenceMetadata("DEVICE_SEGMENT"));
    self.ReferenceTex:CreateResource();
  end
end

function MeanFilter:_OnUpdate(delta)
  if (self.FixedSizeCamera ~= nil and self.ReferenceTex) then
    local texture_size = self.ReferenceTex:GetSize();
    local width  = texture_size:x()
    local height = texture_size:y()
    if width > 0 and height > 0 then
      local newHeight = 240
      local rate = width / height
      local newWidth = math.ceil(rate * newHeight)
      self.FixedSizeCamera:FixedResolution(mathfunction.vector2(newWidth, newHeight));
    else
      ERROR("tex error size " .. tostring(width) ..  "," ..  tostring(height));
    end
  end
end


MeanFilter:MemberRegister("FixedSizeCamera",
  vc.ScriptTypes.ReferenceType(
    ae.CameraComponent:RTTI()
));


return MeanFilter;