local apolloengine = require "apolloengine"
local mathfunction = require "mathfunction"
local venuscore = require "venuscore"
--local fastblur = require "apolloengine.posteffect.fastblur_mask"

local fastblur_alpha = {};

--setmetatable(fastblur_alpha, {__index = fastblur});

fastblur_alpha.RoGuassX_Material = 0;
fastblur_alpha.RoGuassY_Material = 0;
fastblur_alpha.Blit_Material = 0;

fastblur_alpha.RoGuassX_RenderObj = 0;
fastblur_alpha.RoGuassY_RenderObj = 0;
fastblur_alpha.Blit_RenderObj = 0;

function fastblur_alpha:Initialize(host, size)
  self.RoGuassX = 0
  self.RoGuassY = 0
  self.Rt1 = 0;
  self.Rt2 = 0;

  self.Queue = 500;
  
  self.fbosize = mathfunction.vector2(size:x(), size:y());
  self.beginstep = 1;
  self.Blurriness = 1.0;
  self.Stepsize = mathfunction.vector2(1.0, 1.0);
  
  self.GAUSSIAN_STEP = apolloengine.IMaterialSystem:NewParameterSlot(
      apolloengine.ShaderEntity.UNIFORM,
      "GAUSSIAN_STEP");
    
  self.GAUSSUAN_COORDNATE = apolloengine.IMaterialSystem:NewParameterSlot(
      apolloengine.ShaderEntity.INTERNAL,
      "GAUSSUAN_COORDNATE");

  self.POST_EFFECT_ALPHA = apolloengine.IMaterialSystem:NewParameterSlot(
    apolloengine.ShaderEntity.UNIFORM,
    "POST_EFFECT_ALPHA");
  
  local GuassStep = self.Stepsize / size;
  
	--self.RoGuassX = host:CreateRenderObject( "comm:documents/material/gaussianblur.material" );
  -- self.RoGuassX:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
  -- self.RoGuassX:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));
  self.RoGuassX_Material = host:CreateMaterial("comm:documents/material/gaussianblur_mask.material");
  self.RoGuassX_RenderObj = host:CreateRenderObject();
  self.RoGuassX_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
  self.RoGuassX_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));
	
	-- self.RoGuassY = host:CreateRenderObject( "comm:documents/material/gaussianblur.material" );
  -- self.RoGuassY:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
  -- self.RoGuassY:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));
  self.RoGuassY_Material = host:CreateMaterial("comm:documents/material/gaussianblur_mask.material");
  self.RoGuassY_RenderObj = host:CreateRenderObject();
  self.RoGuassY_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
  self.RoGuassY_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));
  
  --self.Blit = host:CreateRenderObject( "comm:documents/material/identity.material" );
  --self.Blit:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));
  self.Blit_Material = host:CreateMaterial("comm:documents/material/identity.material");
  self.Blit_RenderObj = host:CreateRenderObject();
	self.Blit_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(1.0));

	self.Rt1 = host:CreateRenderTarget( apolloengine.RenderTargetEntity.ST_SWAP_A, size );
  self.Rt2 = host:CreateRenderTarget( apolloengine.RenderTargetEntity.ST_SWAP_B, size );
  
  host:RegisterScriptParameter(self, "Blurriness");

  self.MaskTexture = apolloengine.TextureEntity();
  self.MaskTexture:PushMetadata(apolloengine.TextureReferenceMetadata("DEVICE_SEGMENT"));
  self.MaskTexture:SetJobType(venuscore.IJob.JT_SYNCHRONOUS);
  self.MaskTexture:CreateResource();
  self.RoGuassX_Material:SetParameter("MaskTexture", self.MaskTexture);
  self.RoGuassY_Material:SetParameter("MaskTexture", self.MaskTexture);

  host:RegisterScriptParameter(self, "MaskTexture");

  self.InputTexture = apolloengine.TextureEntity();
  self.InputTexture:PushMetadata(apolloengine.TextureReferenceMetadata("LAST_QUEUE_TEXTURE"));
  self.InputTexture:SetJobType(venuscore.IJob.JT_SYNCHRONOUS);
  self.InputTexture:CreateResource();

  host:RegisterScriptParameter(self, "InputTexture");

  host:SetDrawToInput(true);
  self.RoGuassX_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(0.0));
  self.RoGuassY_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(0.0));
  self.Blit_Material:SetParameter(self.POST_EFFECT_ALPHA, mathfunction.vector1(0.0));
  return self.Queue;
end

function fastblur_alpha:Resizeview(size)
  self.fbosize = mathfunction.vector2(size:x(), size:y());
  local GuassStep = self.Stepsize / size;

	-- self.RoGuassX:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
	-- self.RoGuassY:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
  self.RoGuassX_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
	self.RoGuassY_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
end

function fastblur_alpha:_GetCount(newblurriness)
  local icount = math.ceil(newblurriness);
  icount = math.max(icount,1);
  return icount;
end

function fastblur_alpha:_UpdateStepsize(newblurriness, loop)
  local step = newblurriness - loop + 1;
  step = math.max(step, 0) * 4;
  if step ~= self.beginstep then
    --LOG("step "..step);
    self.beginstep = step;
    self.Stepsize:Set(step, step);
    local GuassStep = self.Stepsize / self.fbosize;
    -- self.RoGuassX:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
    -- self.RoGuassY:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
    self.RoGuassX_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( GuassStep:x(), 0 ) );
    self.RoGuassY_Material:SetParameter( self.GAUSSIAN_STEP, mathfunction.vector2( 0, GuassStep:y() ) );
  end
end

-- function fastblur:_FullPass(newblurriness, pipeline, Original, Scene, Output)
function fastblur_alpha:_FullPass(newblurriness, context, Original, Scene, Output)
  local last = Scene;
  local icount = self:_GetCount(newblurriness);
  --LOG("count "..icount)
  local lastTex = last:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 )
  if self.InputTexture then
    lastTex = self.InputTexture;
  end
  for i = 1, icount do
    self:_UpdateStepsize(newblurriness, i);
    --self.Rt1:PushRenderTarget();
    --self.Rt1:ClearBuffer( apolloengine.RenderTargetEntity.CF_COLOR );
    context:BeginRenderPass(self.Rt1,apolloengine.RenderTargetEntity.CF_COLOR);
    -- self.RoGuassX:SetParameter(
    --   apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
    --   last:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 ) );
    self.RoGuassX_Material:SetParameter(
      apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
      lastTex );
    --self.RoGuassX:Draw(pipeline);	
    context:Draw(self.RoGuassX_RenderObj,self.RoGuassX_Material);
    context:EndRenderPass();
    
    --Output:PushRenderTarget();
    --Output:ClearBuffer( apolloengine.RenderTargetEntity.CF_COLOR );
    context:BeginRenderPass(Output,apolloengine.RenderTargetEntity.CF_COLOR);
    -- self.RoGuassY:SetParameter(
    --   apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
    --   self.Rt1:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 ) );
    self.RoGuassY_Material:SetParameter(
      apolloengine.ShaderEntity.TEXTURE_DIFFUSE,
      self.Rt1:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 ) );
    --self.RoGuassY:Draw(pipeline);
    context:Draw(self.RoGuassY_RenderObj,self.RoGuassY_Material);
    context:EndRenderPass();
    last = Output;
    lastTex = last:GetAttachment( apolloengine.RenderTargetEntity.TA_COLOR_0 )
  end
  --LOG("----------------------------");
end

local BLURRINESS_SCALER = 0.25;
--function fastblur:Process(pipeline, Original, Scene, Output)
function fastblur_alpha:Process(context, Original, Scene, Output)

  -- Deserialization may change
  self.RoGuassX_Material:SetParameter("MaskTexture", self.MaskTexture);
  self.RoGuassY_Material:SetParameter("MaskTexture", self.MaskTexture);

  local newblurriness;
  if type(self.Blurriness) == "number" then
    newblurriness = self.Blurriness * BLURRINESS_SCALER;
  else
    newblurriness = self.Blurriness:x() * BLURRINESS_SCALER;
  end  
  --LOG(newblurriness);
  self:_FullPass(newblurriness, context, Original, Scene, Output);
end

return fastblur_alpha;